
public class Fraction
{
    private int numerator;
    private int denominator;
    
    /**
     * @param n numerator
     * @param d denominator, must not be 0
     * @throws ZeroDenominatorException if denominator is 0
     * @throws NegativeDenominatorException if denominator is < 0
     */
    public Fraction(int n, int d) 
    throws ZeroDenominatorException, NegativeDenominatorException 
    {
        if (d == 0) {
            throw new ZeroDenominatorException();
        }
        if (d < 0) {
            throw new NegativeDenominatorException();
        }
        
        numerator = n;
        denominator = d;
    }
    
    public void setNumerator(int n) {
        numerator = n;
    }
    
    /**
     * @param d denominator, must not be 0
     * @return true on success, false if denominator is 0
     */
    public boolean setDenominator(int d) {
        if (d != 0) {
            denominator = d;
            return true;
        }
        return false;
        
        //denominator = d;
        //return denominator != 0;
    }
    
    public double toDouble() {
        return ((double) numerator) / denominator;
    }
    
    /**
     * @param fr fraction
     */
    public void copy(Fraction fr) {
        //if (fr == null) throw new NullPointerException();
        numerator = fr.numerator;
        denominator = fr.denominator;
    }
}
